/*
 *
 * globals.h -- external variables
 *
 */

extern char version[15];

extern char board[16][16];

extern char words[2000000];
extern long wptr[200000];
extern long wlen[200000];
extern long dict_size;
extern int dict_changed;

extern char plr_tiles[4][7];
extern int plr_scores[4];
extern int plr_skills[4];
extern int mean_pcts[SKILL_LEVELS];
extern int tiles_left[27];
extern int un_tiles[27];
extern int players;

extern char your[4][7];
extern char you[4][5];
extern int human_player;

extern int turn[4];
extern float avg;
extern float cumpct[4];
extern int player_time;
extern int highest;
extern int zero_play;

extern int b1x, b1y, b2x, b2y;

extern char gcgname[20];
extern char evalname[20];
extern char logname[20];
extern char srfile[128];

extern compmove *chead;

extern int game_done;
extern int game_abort;
extern int on_turn;
extern int sr_status;

extern struct another_word new_words[10];

extern struct let_distrib letters[27];

extern int normal_dist[40];
extern int normal_sum;

#define QX(A) A

/* curses & other stuff */
#include <curses.h>
#include <stdlib.h>

int wrefresh();
int endwin();
int stty();
int wmove();
int wgetch();
int waddch();
int fclose();
int wclear();

/* cmove.c */

void computer_move QX((int));
void init_cmove QX((int));
int first_move QX((int));
void pick_word QX((int));
int cpu_move QX((int));
void try_tiles QX((int, int, int, int));
void eval_score QX((char *, char *, int, int, int, int));

/* misc.c */

void check_dick QX((void));
void read_words QX((void));
void clear_rect QX((int, int, int, int));
void clear_prompt QX((void));
void clear_turn QX((void));
void press_return QX((void));
void print_board QX((void));
void write_board QX((void));
void print_tiles QX((void));
void print_first_tiles QX((void));
void print_un_tiles QX((void));
void count_letters QX((void));
char draw_tile QX((void));
void print_tiles_left QX((void));
void print_passed_turns QX((void));
void print_whos_move QX((int));
void print_version QX((void));
void screen_redraw QX((void));

void gcg_rack QX((int));
void open_gcg QX((void));
void open_eval QX((void));

void print_eval QX((int));
void eval_rack QX((int));
int check_word QX((char *));
void thatsallfolks QX((void));

int save_game QX((void));
int restore_game QX((void));
void enter_name QX((int));

char get_key QX((void));
void seed_random QX((void));
long get_random QX((void));

extern FILE *logptr;
extern FILE *gcgptr;
extern char saved_rack[8];
extern FILE *evalptr;

/* pmove.c */

void player_move QX((void));
int place_tiles QX((int, int));
void show_instructions QX((void));
int rearrange_tiles QX((void));
void disp_instr QX((void));
int draw_new_tiles QX((void));

/* score.c */

int find_new_words QX((struct plrlet *, int, int, int));
long bin_search QX((char *));
void display_words QX((int, struct plrlet *, int, int));
void add_dict QX((char *));

/* smain.c */

void set_up_window QX((void));
void exit_window QX((void));
void init_board QX((void));
void print_info QX((void));
void init_tiles QX((void));
void get_num_players QX((void));
void end_game QX((void));
void aborthandler QX((int));
void open_log QX((void));
int main QX((void));
