#include <time.h>
#include <stdio.h>
#include <unistd.h>
#include "scram.h"
#include "globals.h"

FILE *saveptr;
char magic[13] = { "SCRAMBLESAVE" };

/* Need this to avoid compiler warning on some GCC compilers. */
size_t dummy;

int save_game () {
  time_t now;
  
  enter_name(1);
  saveptr=fopen(srfile,"wb");
  if (saveptr == NULL ) {
    clear_rect( 23, 0, 22, 79 );
    move (23, 0);
    printw("Failed to open save file %s", srfile);
    refresh();
    sleep(2);
    return(1);
  } else {

  dummy = fwrite(magic,sizeof(magic),1,saveptr);
  dummy = fwrite(board,sizeof(board),1,saveptr);
  dummy = fwrite(turn,sizeof(turn),1,saveptr);
  dummy = fwrite(cumpct,sizeof(cumpct),1,saveptr);
  dummy = fwrite(&player_time,sizeof(player_time),1,saveptr);
  dummy = fwrite(&players,sizeof(players),1,saveptr);
  dummy = fwrite(plr_tiles,sizeof(plr_tiles),1,saveptr);
  dummy = fwrite(plr_scores,sizeof(plr_scores),1,saveptr);
  dummy = fwrite(plr_skills,sizeof(plr_skills),1,saveptr);
  dummy = fwrite(mean_pcts,sizeof(mean_pcts),1,saveptr);
  dummy = fwrite(&normal_sum,sizeof(normal_sum),1,saveptr);
  dummy = fwrite(tiles_left,sizeof(tiles_left),1,saveptr);
  dummy = fwrite(your,sizeof(your),1,saveptr);
  dummy = fwrite(you,sizeof(you),1,saveptr);
  dummy = fwrite(&human_player,sizeof(human_player),1,saveptr);
  dummy = fwrite(&b1x,sizeof(b1x),1,saveptr);
  dummy = fwrite(&b1y,sizeof(b1y),1,saveptr);
  dummy = fwrite(&b2x,sizeof(b2x),1,saveptr);
  dummy = fwrite(&b2y,sizeof(b2y),1,saveptr);
  dummy = fwrite(&game_done,sizeof(game_done),1,saveptr);
  dummy = fwrite(&game_abort,sizeof(game_abort),1,saveptr);
  dummy = fwrite(&on_turn,sizeof(on_turn),1,saveptr);
  dummy = fwrite(gcgname,sizeof(gcgname),1,saveptr); 
  dummy = fwrite(evalname,sizeof(evalname),1,saveptr); 
  fclose(saveptr);
  fprintf(gcgptr, "#note Game saved to: %s\n", srfile);
  fprintf(evalptr, "#note Game saved to: %s\n", srfile);

  time(&now);
  fprintf(logptr, "SAVE        %s %s %s %s", srfile, gcgname, evalname, ctime(&now));

  return(0);
  }
}

int restore_game () {
  time_t now;
  
  enter_name(2);
  saveptr=fopen(srfile,"rb");
  if (saveptr == NULL ) {
    clear_rect( 23, 0, 22, 79 );
    move (23, 0);
    printw("Failed to open save file %s", srfile);
    refresh();
    sleep(2);
    return(1);
  } else {

  dummy = fread(magic,sizeof(magic),1,saveptr);
  if (strcmp(magic,"SCRAMBLESAVE") != 0) {
    clear_rect( 23, 0, 22, 79 );
    move (23, 0);
    printw("%s is not a valid Scrambler save file", srfile);
    refresh();
    sleep(2);
    return(1);
  }
  
  dummy = fread(board,sizeof(board),1,saveptr);
  dummy = fread(turn,sizeof(turn),1,saveptr);
  dummy = fread(cumpct,sizeof(cumpct),1,saveptr);
  dummy = fread(&player_time,sizeof(player_time),1,saveptr);
  dummy = fread(&players,sizeof(players),1,saveptr);
  dummy = fread(plr_tiles,sizeof(plr_tiles),1,saveptr);
  dummy = fread(plr_scores,sizeof(plr_scores),1,saveptr);
  dummy = fread(plr_skills,sizeof(plr_skills),1,saveptr);
  dummy = fread(mean_pcts,sizeof(mean_pcts),1,saveptr);
  dummy = fread(&normal_sum,sizeof(normal_sum),1,saveptr);
  dummy = fread(tiles_left,sizeof(tiles_left),1,saveptr);
  dummy = fread(your,sizeof(your),1,saveptr);
  dummy = fread(you,sizeof(you),1,saveptr);
  dummy = fread(&human_player,sizeof(human_player),1,saveptr);
  dummy = fread(&b1x,sizeof(b1x),1,saveptr);
  dummy = fread(&b1y,sizeof(b1y),1,saveptr);
  dummy = fread(&b2x,sizeof(b2x),1,saveptr);
  dummy = fread(&b2y,sizeof(b2y),1,saveptr);
  dummy = fread(&game_done,sizeof(game_done),1,saveptr);
  dummy = fread(&game_abort,sizeof(game_abort),1,saveptr);
  dummy = fread(&on_turn,sizeof(on_turn),1,saveptr);
  dummy = fread(gcgname,sizeof(gcgname),1,saveptr); 
  dummy = fread(evalname,sizeof(evalname),1,saveptr); 

  fclose(saveptr);

  /* We must deal with gcg and eval files here, and after, a note to
     the files about restoring. */

 if ( access (gcgname, W_OK ) == 0 ) {
      gcgptr = fopen(gcgname, "a+");
  } else {
    clear_rect( 23, 0, 22, 79 );
    move (23, 0);
    printw("Can't open GCG file %s, opening new one", gcgname);
    refresh();
    sleep(1);
    open_gcg();
  }
  fprintf(gcgptr, "#note Game restored from: %s\n", srfile);
     if ( access (evalname, W_OK ) == 0 ) {
	  evalptr = fopen(evalname, "a+");
	} else {
      clear_rect( 23, 0, 22, 79 );
      move (23, 0);
      printw("Can't open EVAL file %s, opening new one", evalname);
      refresh();
      sleep(1);
      open_eval();
    }
     fprintf(evalptr, "\nNote: Game restored from: %s\n\n", srfile);
      print_version();
      seed_random();
      print_board();
      print_tiles();
      print_info();
      print_un_tiles();
      print_tiles_left();
      print_passed_turns();
      clear_prompt();
      refresh();
      time(&now);
      fprintf(logptr, "RESTORE     %s %s %s %s", srfile, gcgname, evalname, ctime(&now));

      return(0);
  }
}

void enter_name(int s_or_r) {
  int i, cn, abort;
  
  clear_rect ( 23, 1, 23, 79 );
  move ( 23, 0 );
  if (s_or_r ==  1) {
    printw( "Save to file: ");
  } else if (s_or_r == 2) {
      printw( "Restore from file: ");
  } else {
    move( 20, 0 );
    printw("Logic error in enter_name");
    sleep(2);
    game_abort=6;
    thatsallfolks();
    refresh();
  }
  i=0;
  abort=0;
  do {
    srfile[i]='\0';
    cn=getch();
    switch (cn) {
    case '\n' : break;
      /* backsp */
    case 8 :
    case 127 :
      if (i > 0) {
	i--;
	srfile[i]='\0';
	/* need to backspace over prev char and clear */
	printw("\b \b");
      }
      break;
    case 27 :
      abort = 1;
    default : 
      srfile[i]=cn;
      i++;
      printw("%c",cn);
      break;
    }
  } while (cn != '\n' && i < 67 && abort==0);
}
